//-------------------------------------------------------------------
// FILENAME    : cross_over.cpp
// DESCRIPTION : Cross over
//-------------------------------------------------------------------
#include <iostream>
#include <math.h>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include "cross_over.h"
#include "select.h"
#include "gene.h"
#include "pop.h"

double Cross::cross_r=1.0;
int Cross::cross_method=1;
int Cross::plan_num=0;
int Cross::chromo_len=0;
int Cross::child_num=2;
int Cross::need_num=2;

Cross::~Cross()
{
}

void Cross::cross_over(Pop& a)
{
  pop_num=a.get_pop_num();
  cross_over(a.ap_gene,pop_num);
  a.set_pop_num(pop_num);
}

void Cross::cross_over(Gene **ap_gene,int &num)
{
  int i,j,birth_pop_num,remain,int_roop;
  double roop,dum;
  pop_num=num;

  random_shuffle(ap_gene,pop_num);

  birth_pop_num=(int)((double)pop_num*cross_r);
  dum=(double)birth_pop_num;
  roop=(double)birth_pop_num/(double)(need_num);
  remain=(int)((int)dum%(need_num));
  roop=ceil(roop);
  int_roop=(int)roop;

  for(i=0;i<int_roop;i++){
    if(i!=(int_roop-1)){
      for(j=0;j<(need_num);j++){
	Parent[j] = *ap_gene[i*(need_num)+j];
      }
    }
    else{
      for(j=0;j<(need_num);j++){
	Parent[j]=*ap_gene[(pop_num-1)-j];
      }
    }

    cross_method_exe(ap_gene,pop_num);

    if(i!=(int_roop-1)){
      for(j=0;j<(need_num);j++){
	*ap_gene[i*(need_num)+j]=Child[j];
	ap_gene[i*(need_num)+j]->change_flag=CHANGE;
      }
    }
    else{
      for(j=0;j<remain;j++){
	*ap_gene[i*(need_num)+j]=Child[j];
	ap_gene[i*(need_num)+j]->change_flag=CHANGE;
      }
    }
  }
}

void Cross::random_shuffle(Gene **ap_gene,const int &tmp_number)
{
  pop_num=tmp_number;
  int ran_dom,k,j,i;
  vector<u8> flag(pop_num);
  for(i=0;i<pop_num;i++)
    flag[i]=1;
  
  for(i=0;i<pop_num;i++){
    ran_dom = genrand_int(pop_num-i);
    k=0;
    j=0;
    do{
      if(flag[j])
	k++;
      j++;
    }while(k<=ran_dom);
    flag[(j-1)]=0;
    ap_gene[i]->get_f()=(double)(j-1);
  }
  f_qsort(ap_gene,0,pop_num-1);
}


void Cross::cross_method_exe(Gene **ap_gene,const int& num)
{
  int k,hD,cross_point;
  vector<char>  flagString(chromo_len);
  vector<int>   hit_point(chromo_len);
  
  Child[0]=Parent[1];
  Child[1]=Parent[0];
  
  for(k=0,hD=0;k<chromo_len;k++){
    flagString[k] =  Parent[0].get_locus(k)^Parent[1].get_locus(k);
    if(flagString[k])
      hit_point[hD]=k;
    hD += flagString[k];	     
  }
  
  if(hD<=1){
    //    cout<<"the same (hD= "<<hD<<")\n";
    return;
  }
  else{
    if(cross_method==1){
      k=genrand_int(hD-1);
      cross_point=hit_point[k+1];    
      One_point(cross_point);
    }
    else{
      Two_point();
    }
  }
}

void Cross::One_point(const int &cross_point)
{
  int j;
  for(j=cross_point;j<chromo_len;j++){
    Child[0].get_locus(j)=Parent[0].get_locus(j);
    Child[1].get_locus(j)=Parent[1].get_locus(j);
  }
}

void Cross::Two_point()
{
  int j,dum;
  int start,end;
  
  do{
    start=genrand_int(chromo_len-2);
    end= 1 + genrand_int(chromo_len-1);
  }while(start==end);
  
 if(start>end){
   dum=start;
   start=end;
   end=dum;
 }

// cout<<"start-end"<<start<<"-"<<end<<"\n";

 for(j=start;j<end;j++){
   Child[0].get_locus(j)=Parent[0].get_locus(j);
   Child[1].get_locus(j)=Parent[1].get_locus(j);
 }
}


/*
  CMX is the head character of Centralized Multiple Crossover.
  This method execution multiple crossover.
  The following function 
 */
void Cross::CMX_cross_over(Gene **ap_gene,int &tmp_number,const int& what_times)
{
  int j,i,h,dum;
  dum=0;
  pop_num=tmp_number;

  for(i=0;i<(pop_num/need_num);i++){
    for(j=0;j<(need_num);j++)
      Parent[j]=*ap_gene[i*need_num + j];  
    
    for(h=0;h<what_times;h++){
	  if( genrand() <= cross_r){
	      cross_method_exe(ap_gene,pop_num);
    	  for(j=0;j<(need_num);j++){
			*ap_gene[(i*what_times+h)*need_num +j]=Child[j];
			ap_gene[(i*what_times+h)*need_num + j]->change_flag=CHANGE;
      	}
      }
    }
  }
  tmp_number *=  what_times;
}



