//-------------------------------------------------------------------
// FILENAME    : cross_over.h
// DESCRIPTION : Cross over
//-------------------------------------------------------------------
#ifndef _CROSS_OVER_CPP_H_
#define _CROSS_OVER_CPP_H_
#include <stdlib.h>
#include <float.h>

#include "pop.h"
#include "mtrand.h"
#include "gene.h"

class Cross
{
  Gene Child[2],Parent[2];
 protected:
  static double cross_r;
  static int cross_method;
  static int plan_num;
  static int child_num;
  static int need_num;
  static int chromo_len;
  int pop_num;
  mutable MTRand mtrand;	
 public:
  virtual ~Cross();
  inline double genrand() const {return (mtrand.genrand());}
  inline int genrand_int(int n) const {return (mtrand.genrand_int(n));}
  inline double get_cross_r()	{return cross_r;}
  inline void set_cross_r(double x)	{cross_r=x;}
  inline int get_need_num() {return need_num;}
  inline int get_cross_method()   {return cross_method;}
  inline void set_cross_method(int x)     {cross_method=x;}
  inline int get_pop_num()        {return pop_num;}
  inline void set_pop_num(int x)  {pop_num=x;}
  inline void set_plan_num(const int &x) {plan_num=x;}
  inline void set_chromo_len(const int &x) {chromo_len=x;}
  virtual void cross_over(Pop& a);
  virtual void cross_over(Gene **,int &);
  virtual void random_shuffle(Gene **ap_gene,const int &tmp_number);
  virtual void cross_method_exe(Gene **,const int &);
  virtual void One_point(const int &cross_point);
  virtual void Two_point();
  virtual void CMX_cross_over(Gene **ap_gene,int &tmp_number,const int& what_times);

};

#endif //_CROSS_OVER_CPP_H_
