//-------------------------------------------------------------------
// FILENAME    : func_numberical.cpp
// DESCRIPTION : Function of Numerical function
//-------------------------------------------------------------------
#include <stdio.h>
#include <iostream>
#include <math.h>
#include "base.h"
#include "gene.h"
#include "pop.h"
#include "func.h"
#include "func_numerical.h"

void Numerical_func::func(Pop& a)
{
	pop_num=a.get_pop_num();
	func(a.ap_gene,pop_num);
}

void Numerical_func::func(Gene **ap_gene,const int &dum_pop)
{
  int i;
  pop_num=dum_pop;
  for(i=0;i<pop_num;i++){
 	if(ap_gene[i]->change_flag){
      func(*ap_gene[i]);
    }
  }
}

void Numerical_func::func(Gene &ap_gene)
{
  if(func_number==1)
    func1(ap_gene);
  else if(func_number==2)
    func2(ap_gene);
  else if(func_number==3)
    func3(ap_gene);
  else if(func_number==4)
    func4(ap_gene);
  else if(func_number==5)
    func5(ap_gene);
  else if(func_number==6)
    func6(ap_gene);
  else if(func_number==7)
    func7(ap_gene);
  else if(func_number==8)
    func8(ap_gene);
  else if(func_number==9)
    func9(ap_gene);
  else if(func_number==10)
    func10(ap_gene);
  else if(func_number==11)
    func11(ap_gene);
  else if(func_number==12)
    func12(ap_gene);
  else if(func_number==13)
    func13(ap_gene);
  else if(func_number==14)
    func14(ap_gene); // DTLZ1
  else if(func_number==15)
    func15(ap_gene);// DTLZ2
  else if(func_number==16)
    func16(ap_gene);// DTLZ7
  else{
//    printf("In func kannsuu is fault number! plsase reput corect number! now %d\n",func_number);
    exit(0);
  }
  ap_gene.change_flag=NOCHANGE;
  func_count ++;
  sleep();
}

void Numerical_func::func1(Gene &ap_gene)
{
  double x0_2;
  x0_2=pow((double)ap_gene.get_locus_value(0),2.0);
  ap_gene.get_e(0) = (1.0/4.0)*x0_2;
  ap_gene.get_e(1) = (double)ap_gene.get_locus_value(0)*(1.0-(double)ap_gene.get_locus_value(1)) + 5.0;
}

void Numerical_func::func2(Gene &ap_gene)
{
  double x0_2;

  x0_2=pow((double)ap_gene.get_locus_value(0),2.0);
  ap_gene.get_e(0) = x0_2 - (double)ap_gene.get_locus_value(1);
  ap_gene.get_e(1) = (-1.0/2.0)*((double)ap_gene.get_locus_value(0))-(double)ap_gene.get_locus_value(1)-1.0;
}

void Numerical_func::func3(Gene &ap_gene)
{
  ap_gene.get_e(0) = -2.0*(double)ap_gene.get_locus_value(0) + (double)ap_gene.get_locus_value(1);
  ap_gene.get_e(1) = (double)ap_gene.get_locus_value(1);
}

void Numerical_func::func4(Gene &ap_gene)
{
  double x0_2,x1_2,x_2,dum_1,dum_2;

  x0_2=pow((double)ap_gene.get_locus_value(0),2.0);
  x1_2=pow((double)ap_gene.get_locus_value(1),2.0);
  x_2=x0_2+x1_2;

  dum_1 = 3.0*(double)ap_gene.get_locus_value(0) - 2*(double)ap_gene.get_locus_value(1)+4.0;
  dum_1 = pow(dum_1,2.0);
  dum_2 = (double)ap_gene.get_locus_value(0) - (double)ap_gene.get_locus_value(1) + 1.0;
  dum_2 = pow(dum_2,2.0);

  ap_gene.get_e(0)=0.5*(x_2)+sin(PI*x_2);  /* sin(x) is unbelivable */
  ap_gene.get_e(1)= dum_1/8.0 + dum_2/27.0 + 15.0;
  ap_gene.get_e(2)= 1.0/(x_2+1.0)-1.1*exp(-x_2);
}


void Numerical_func::func5(Gene &ap_gene)
{
  ap_gene.get_e(0) = 2.0*sqrt(ap_gene.get_locus_value(0));
  ap_gene.get_e(1) = ap_gene.get_locus_value(0)*(1.0-ap_gene.get_locus_value(1)) + 5.0;
}

void Numerical_func::func6(Gene &ap_gene)
{
  double g,g_s,h;
  int j;
  ap_gene.get_e(0) = ap_gene.get_locus_value(0);
  g_s=0.0;
  for(j=1;j<plan_num;j++)
    g_s += pow(ap_gene.get_locus_value(j),2.0)-10.0*cos(2*PI*ap_gene.get_locus_value(j)); 
  
  g=1.0+10.0*(double)(plan_num-1)+g_s;
  if(ap_gene.get_e(0)<=g)
    h=1.0-sqrt(ap_gene.get_e(0)/g);
  else
    h=0.0;
  ap_gene.get_e(1) = g*h;
}

void Numerical_func::func7(Gene &ap_gene)
{
  int j;
  double g,g_s,h,dum;

  dum=sin(5.0*PI*ap_gene.get_locus_value(0));
  ap_gene.get_e(0) = 1.0-exp(-4.0*ap_gene.get_locus_value(0))*pow(dum,6.0);
  g_s=0.0;

  for(j=1;j<plan_num;j++)
    g_s += ap_gene.get_locus_value(j);
  g_s = g_s/(double)(plan_num-1);
  
  g_s = pow(g_s,0.25);
  g=1+10*g_s;
  if(ap_gene.get_e(0)<=g)
    h=1.0-pow(ap_gene.get_e(0)/g,2.0);
  else
    h=0.0;
  ap_gene.get_e(1) = g*h;
}


void Numerical_func::func8(Gene &ap_gene)
{
  int j;
  double g,g_s,h;

  ap_gene.get_e(0) = ap_gene.get_locus_value(0);
  g_s=0.0;
  for(j=1;j<plan_num;j++)
    g_s += ap_gene.get_locus_value(j);
  g_s = g_s/(double)(plan_num-1);  
  g=1+10*g_s;
  if(ap_gene.get_e(0)<=g)
    h=1.0-pow(ap_gene.get_e(0)/g,2.0);
  else
    h=0.0;
  ap_gene.get_e(1) = g*h;
}

void Numerical_func::func9(Gene &ap_gene)
{
  int j;
  double g,g_s,h,dum;

  ap_gene.get_e(0) = ap_gene.get_locus_value(0);
  g_s=0.0;
  for(j=1;j<plan_num;j++)
    g_s += ap_gene.get_locus_value(j);
  g_s = g_s/(double)(plan_num-1);  
  g=1+10*g_s;
  dum=ap_gene.get_e(0)/g;
  h=1.0-pow(dum,0.25)-dum*sin(10*PI*ap_gene.get_e(0));
  ap_gene.get_e(1) = g*h;
}

//func10 is ZDT4
void Numerical_func::func10(Gene &ap_gene)
{
  int j;
  double g_s,h,dum;

  ap_gene.get_e(0) = ap_gene.get_locus_value(0);
  g_s = 91.0;
  for(j=1;j<plan_num;j++){
    g_s += pow(ap_gene.get_locus_value(j),2.0)-10*cos(4*PI*ap_gene.get_locus_value(j));
  }
  dum=ap_gene.get_locus_value(0)/g_s;
  h=1.0-sqrt(dum);
  ap_gene.get_e(1) = g_s*h;

}

//func11 is ZDT6
void Numerical_func::func11(Gene &ap_gene)
{
  int j;
  double g,g_s,h,dum;

  dum=sin(6.0*PI*ap_gene.get_locus_value(0));
  ap_gene.get_e(0) = 1.0-exp(-4.0*ap_gene.get_locus_value(0))*pow(dum,6.0);
  g_s=0.0;

  for(j=1;j<plan_num;j++)
    g_s += ap_gene.get_locus_value(j);
  g_s = g_s/(double)(plan_num-1);
  
  g_s = pow(g_s,0.25);
  g=1+9*g_s;
  dum=ap_gene.get_e(0)/g;
  h=1.0-pow(dum,2.0);
  ap_gene.get_e(1) = g*h;
}

//func12 is SPH-m
void Numerical_func::func12(Gene &ap_gene)
{
  int i,j;
  double dum;

  for(j=0;j<obj_num;j++){
    dum=0.0;
    for(i=0;i<plan_num;i++){
      if(i==j)
	continue;
      dum += pow(ap_gene.get_locus_value(i),2.0);
    }
    dum += pow((ap_gene.get_locus_value(j)-1.0),2.0);
    ap_gene.get_e(j)=dum;
  }
}


//func13 is KUR
void Numerical_func::func13(Gene &ap_gene)
{
  int i;
  double g,g_s,dum;

  g_s=0.0;
  for(i=0;i<(plan_num-1);i++){
    dum = pow(ap_gene.get_locus_value(i),2.0)+pow(ap_gene.get_locus_value(i+1),2.0);
    dum = sqrt(dum);
    g_s += -10 * exp(-0.2*dum);
  }
  ap_gene.get_e(0)=g_s;

  g_s=0.0;
  for(i=0;i<(plan_num);i++){
    dum=fabs(ap_gene.get_locus_value(i));
    dum = pow(dum,0.8);
    g=pow((ap_gene.get_locus_value(i)),3.0);
    g= 5 * sin(g);
    g_s += dum + g; 
  }
  ap_gene.get_e(1)=g_s;
}

//func14 is DTLZ1
void Numerical_func::func14(Gene &ap_gene)
{
  int i,j,k;
  double g,g_s,dum;

  //k is the number of variable x_M. 
  //Therefore, total number of variable = objectives(M) -1 + k 

	k=plan_num-obj_num+1;

  dum=0.0;
/**************
   for(i=0;i<k;i++)
  	dum += pow(ap_gene.get_locus_value(i),2.0);
  g_s = sqrt(dum);
 **************/
  g_s=k;
  
  for(i=0,dum=0.0;i<k;i++){
  	dum += pow(ap_gene.get_locus_value(i)-0.5,2.0) -cos(20*PI*(ap_gene.get_locus_value(i)-0.5));
  }
  g_s += dum;
  g = 100*g_s;
  	for(i=0;i<obj_num;i++){
		dum = (1.0+g)/2.0;
		for(j=0;j<(obj_num-i);j++){
			if(j==(obj_num-i-1)){
				if(i!=0)
					dum *= (1-ap_gene.get_locus_value(j+k));
			}
			else{
				dum *= ap_gene.get_locus_value(j+k);
			}
		}
		ap_gene.get_e(i)=dum;
	}
}


//func15 is DTLZ2
void Numerical_func::func15(Gene &ap_gene)
{
  int i,j,k;
  double g,g_s,dum;

  k=plan_num-obj_num+1;

  dum=0.0;
   for(i=0;i<k;i++)
  	dum += pow(ap_gene.get_locus_value(i)-0.5,2.0);
  g =dum;
  
  	for(i=0;i<obj_num;i++){
		dum = (1.0+g);
		for(j=0;j<(obj_num-i);j++){
			if(j==(obj_num-i-1)){
				if(i!=0)
					dum *= sin(PI/2*ap_gene.get_locus_value(j+k));
			}
			else{
				dum *= cos(PI/2*ap_gene.get_locus_value(j+k));
			}
		}
		ap_gene.get_e(i)=dum;
	}
}


//func16 is DTLZ7
void Numerical_func::func16(Gene &ap_gene)
{
  int i,j,k;
  double g,g_s,dum;

	g=(plan_num/obj_num);
  	for(j=0;j<obj_num;j++){
  		dum =0.0;
		for(i=(j-1)*(int)g;i<j*(int)g;i++){
			dum += ap_gene.get_locus_value(i);
		}
		ap_gene.get_e(j) = dum/g;
	}
}

void Numerical_func::pop_create(Pop &a)
{
  pop_num=a.get_pop_num();
  pop_create(a.ap_gene,pop_num);
}

void Numerical_func::pop_create(Gene **ap_gene,const int& num)
{
  pop_num=num;
  pop_create(ap_gene,0,pop_num);
}

void Numerical_func::pop_create(Gene **ap_gene,const int first,const int end)
{
  int i,k;
  for(i=first;i<end;i++){
    ap_gene[i]->change_flag=CHANGE;
    ap_gene[i]->safe_flag=SAFE;
  }
  int chromo_len=Gene::get_chromo_len();
  for(i=first;i<end;i++){
    for(k=0;k<chromo_len;k++){
      ap_gene[i]->get_locus(k) = rand_int(2);
    }
    func(*ap_gene[i]);
  }
}


double Numerical_func::real_func(Pop &pop)
{
  double dum;
  int i,j;

  pop_num= pop.get_pop_num();
  dum=0.0;
  j=0;
  if(func_number==1){
    for(i=0;i<pop_num;i++)
      if(pop.ap_gene[i]->safe_flag==SAFE){
	dum += real_func1(*pop.ap_gene[i]);
	j++;
      }
  }
  else if(func_number==5){
    for(i=0;i<pop_num;i++)
      if(pop.ap_gene[i]->safe_flag==SAFE){
	dum += real_func5(*pop.ap_gene[i]);
	j++;
      }
  }
  else if(func_number==10){
    for(i=0;i<pop_num;i++)
      if(pop.ap_gene[i]->safe_flag==SAFE){
	dum += real_func10(*pop.ap_gene[i]);
	j++;
      }
  }
  else if(func_number==11){
    for(i=0;i<pop_num;i++)
      if(pop.ap_gene[i]->safe_flag==SAFE){
	dum += real_func11(*pop.ap_gene[i]);
	j++;
      }
  }
  else if(func_number==12){
    for(i=0;i<pop_num;i++)
      if(pop.ap_gene[i]->safe_flag==SAFE){
	dum += real_func12(*pop.ap_gene[i]);
	j++;
      }
  }
  else if(func_number==14){
    for(i=0;i<pop_num;i++)
      if(pop.ap_gene[i]->safe_flag==SAFE){
	dum += real_func14(*pop.ap_gene[i]);
	j++;
      }
  }
  else if(func_number==15){
    for(i=0;i<pop_num;i++)
      if(pop.ap_gene[i]->safe_flag==SAFE){
	dum += real_func15(*pop.ap_gene[i]);
	j++;
      }
  }
   else if(func_number==16){
    for(i=0;i<pop_num;i++)
      if(pop.ap_gene[i]->safe_flag==SAFE){
	dum += real_func16(*pop.ap_gene[i]);
	j++;
      }
   }
  else{
    printf("In func kannsuu is fault number! plsase reput corect number! now %d\n",func_number);
  }
  pop.flag_change_safe();
  return (dum/(double)j);
}

double Numerical_func::real_func1(Gene &ap_gene)
{
  double r_f[obj_num],dum;
  r_f[0]=ap_gene.get_e(0);
  r_f[1]=25.0-10.0*ap_gene.get_e(1) + pow(ap_gene.get_e(1),2.0);
  r_f[1] /=4;
  dum = fabs(r_f[1]-r_f[0]);
  return (dum);
}

double Numerical_func::real_func5(Gene &ap_gene)
{
  double r_f[obj_num],dum;
  r_f[0]=ap_gene.get_e(1);
  r_f[1]= 5.0 - pow(ap_gene.get_e(0),2.0)/4.0;
  dum = fabs(r_f[0]-r_f[1]);
  return (dum);
}

double Numerical_func::real_func10(Gene &ap_gene)
{
  double r_f[obj_num],dum;
  r_f[0]=ap_gene.get_locus_value(0);
  r_f[1]=1.0-sqrt(r_f[0]);
  dum = ap_gene.get_e(1)-r_f[1];
  return (dum);
}

//func11 is ZDT6
double Numerical_func::real_func11(Gene &ap_gene)
{
  double r_f[obj_num],dum;

  dum=sin(6.0*PI*ap_gene.get_locus_value(0));
  r_f[0] = 1.0-exp(-4.0*ap_gene.get_locus_value(0))*pow(dum,6.0);
  r_f[1]=1.0-pow(r_f[0],2.0);

  dum = ap_gene.get_e(1)-r_f[1];
  return (dum);
}

//func12 is SPH-m
double Numerical_func::real_func12(Gene &ap_gene)
{
  int i,j;
  double dum,r_f[obj_num],dum2,r_locus[obj_num];

  for(j=0;j<obj_num;j++){
    if(ap_gene.get_locus_value(j)<0.0)
      r_locus[j]=0.0;
    else if(ap_gene.get_locus_value(j)>1.0)
      r_locus[j]=1.0;
    else
      r_locus[j]=ap_gene.get_locus_value(j);
  }
  
  dum2=0.0;
  for(j=0;j<obj_num;j++){
    dum=0.0;
    for(i=0;i<obj_num;i++){
      if(i==j)
	dum += pow((r_locus[i]-1.0),2.0);
      else
	dum += pow(r_locus[i],2.0);
    }
    r_f[j]=dum;
    dum2 += ap_gene.get_e(j) - r_f[j];
  }
  return dum2;
}


//func14 is DTLZ1
double Numerical_func::real_func14(Gene &ap_gene)
{
	int i;
	double dum;
	for(i=0,dum=0.0;i<obj_num;i++){
  	  dum += ap_gene.get_e(i);
      }
	dum -= 0.5;
  return (dum);
}


//func118:05 2003/06/25 is DTLZ2
double Numerical_func::real_func15(Gene &ap_gene)
{
	int i;
	double dum;
	for(i=0,dum=0.0;i<obj_num;i++){
  	  dum += ap_gene.get_e(i);
      }
	dum -= 1;
  return (dum);
}

//func118:05 2003/06/25 is DTLZ7
double Numerical_func::real_func16(Gene &ap_gene)
{
	int i,j;
	double dum,min,f_sum;
	for(i=0,dum=0.0;i<obj_num-1;i++){
  	  dum += ap_gene.get_e(obj_num-1) + 4*ap_gene.get_e(i) -1;
      }
      
	min=INT_MAX;
	for(i=0;i<obj_num-1;i++){
		for(j=0;j<obj_num-1;j++){
			if(i==j)
      	  	  continue;
      	  	  f_sum=ap_gene.get_e(i)+ap_gene.get_e(j);
      	  	  if(min>f_sum)
      	  	  	  min=f_sum;
      	}  
    }
    dum += 2*ap_gene.get_e(obj_num-1)+min -1;
  return (dum);
}



void Numerical_func::set_func_number(const int &x)
{
  func_number = x;
  if(func_number==1){
    plan_num=2;
    obj_num=2;
  }
  else if(func_number==2){
    plan_num=2;
    obj_num=2;
  }
  else if(func_number==3){
    plan_num=2;
    obj_num=2;
  }
  else if(func_number==4){
    plan_num=2;
    obj_num=3;
  }
  else if(func_number<14){
    obj_num=2;
    plan_num=10;
  }
  else{
    obj_num=3;
    plan_num=10;
  }
}

void Numerical_func::set_func_number(const int &x,const int &y)
{
  func_number = x;
  plan_num=y;
  if(func_number==1){
    plan_num=2;
    obj_num=2;
  }
  else if(func_number==2){
    plan_num=2;
    obj_num=2;
  }
  else if(func_number==3){
    plan_num=2;
    obj_num=2;
  }
  else if(func_number==4){
    plan_num=2;
    obj_num=3;
  }
  else if(func_number<14){
    obj_num=2;
  }
}

void Numerical_func::set_func_number(const int &x,const int &y,const int &z)
{
  func_number = x;
  obj_num=y;
  plan_num=z;
  if(func_number != 12&&func_number<14)
    set_func_number(func_number,plan_num);
  
  if(func_number==14||func_number==15){
  	  if(plan_num<(obj_num+5))
  	  	  plan_num=obj_num+5;
  }
  if(func_number==16)
  	  if(((plan_num/obj_num)%10)){
  	  	  plan_num=10*obj_num;
  }
}
