//-------------------------------------------------------------------
// FILENAME    : loadconf.h
// DESCRIPTION : Loading Configuration Data
//-------------------------------------------------------------------
#if !defined(_CPP_LOADCONF_H_)
#define _CPP_LOADCONF_H_

class Conffile
{
	int nvars_;       // number of variables
	struct VARINFO
	{
		char *name;  // variable name
		char *value; // variable value
	} *list_;

	static const char *SPACE_CHARS;
	static const char *SPACE_AND_EQUAL_CHARS;

	static char *seek_word(char *p);
	static char *next_word(char *p);
	static char *freadline(FILE *fp);

	void destruct();

public:
	// constructor, destructor
	explicit Conffile(const char *fn);
	~Conffile() {destruct();}

	// method
	int write(const char *varname, const char *value);
	const char *read(const char *varname) const;
	const char *name(int n) const {return list_[n].name;}
	const char *value(int n) const {return list_[n].value;}
	int nvars() const {return nvars_;}
	int size() const {return nvars();}
};



#endif // _CPP_LOADCONF_H_
