#ifndef _MT_RAND_CPP_H_
#define _MT_RAND_CPP_H_

#define N_MTRAND_FACTOR 624
#define GRAND_FALSE 0
#define GRAND_TRUE 1

class MTRand
{
	mutable unsigned long mt[N_MTRAND_FACTOR];
	mutable int mti;

public:
	explicit MTRand(unsigned long seed);
	MTRand();
	void srand(unsigned long seed);
	void srandByTime();

	double genrand() const;
	int genrand_int(int n) const;
};

class Gauss_rand
{
	static int got_deviate;
	static double extra_deviate;
	mutable MTRand mtrand;
public:
	Gauss_rand();
	double gen_gauss_rand(double,double);
	inline double genrand() const {return mtrand.genrand();}
};



int seed_by_time();

// MT C Compatible Interface
double genrand();
int genrand_int(int n);
void sgenrand(unsigned long seed);

#endif // _MT_RAND_CPP_H_

