//-------------------------------------------------------------------
// FILENAME    : mutation.h
// DESCRIPTION : Mutation
//-------------------------------------------------------------------
#ifndef _MUTE_CPP_H_
#define _MUTE_CPP_H_

#include <stdlib.h> 
#include <iostream>
#include "mtrand.h"
#include "gene.h"
#include "pop.h"
// #include "func_n.h"

class Mutation
{
protected:
	static int length;
	static double mut_r;
	static int mut_method;
	static int pop_num;
	static int plan_num;
	mutable MTRand mtrand;
public:
        inline double genrand() const {return mtrand.genrand();}
	inline int genrand_int(const int& n) const {return mtrand.genrand_int(n);}
	inline void set_plan_num(const int &x) {plan_num=x;}
	inline void set_mut_method(const int& x)	{mut_method=x;}
	inline int get_mut_method()	{return mut_method;} 
	inline void set_length(const int& x)	{length=x;}
	inline int get_length()	{return length;}
	inline void set_mut_r(const double& x)	{mut_r=x;}
	inline double get_mut_r()	{return mut_r;}
        inline int get_pop_num()        {return pop_num;}
        inline void set_pop_num(const int& x)  {pop_num=x;}
	virtual void mut(Pop &);
	virtual void mut(Gene **,const int &);
	virtual void mutation_exe(Gene &gene,const int &);
	virtual void bit_reverse(Gene &a,const int &);
};


#endif  //_GENE_CPP_H



