//-------------------------------------------------------------------
// FILENAME    : ncga.cpp
// DESCRIPTION : Operating GA  of NCGA
//-------------------------------------------------------------------
#include <iostream>
#include <math.h>
#include <stdlib.h>

#include "ncga.h"
#include "gene.h"
#include "oneisland.h"
#include "select.h"
#include "select_spea2.h"

int Ncga::pareto_count;
int Ncga::child_num=2;
int Ncga::send_count=3;
int Ncga::what_times=1;
int Ncga::obj_base=1;
double Ncga::width_rate=0.045;

Ncga::Ncga(): One()
{
  tmpChild = NULL;
  child_num=2;
}

void Ncga::pareto_creat()
{
  if(perfect_pop.get_pop_num()==0&&generation==0)
    return ;
  else{
    select.set_select_pop_num(variable.pop_num);
    if(pop.get_pop_num()>variable.pop_num){
      select_spea2.select_spea2(pop,variable.pop_num);
      int pop_num=pop.get_pop_num();
      pop.set_pop_num(pop_num);
    }
    else
      pop.set_pop_num(variable.pop_num);
    select_spea2.select_spea2(pop,perfect_pop);
  }
}

Ncga::~Ncga()
{

	int i,dum;
	dum = cross.get_need_num();
	if(tmpChild != NULL){
	  for(i=0;i<dum;i++)
	    delete tmpChild[i];
	  delete[] tmpChild;
	  tmpChild=NULL;
	}
}

void Ncga::initGA()
{
	One::init_base();
	pareto_count=variable.pop_num;
	send_count=cross.get_need_num();
	pop.set_pop_num(variable.pop_num);
	pop.init_ap_gene(pareto_count*(what_times));
	perfect_pop.init_ap_gene(pareto_count*(what_times));
	next_pop.init_ap_gene(pareto_count*(what_times));
	int i;
	tmpChild = new Gene*[send_count];
	for(i=0;i<send_count;i++)
	  tmpChild[i] = new Gene(variable.chromosome_length,variable.obj_num);
}

void Ncga::cycle()
{
  all_open_w_file();
  int loop_count=0;
  fprintf(fp1,"NCGA start \n");
  do{
     fprintf(fp1,"loop %d\n",loop_count);
      fprintf(fp3,"loop %d\n",loop_count);
      initialize();
	  f_output();
	  terminal_check();
    for(;life_flag;){
	  printf("####(loop %d)generation %d start(pop_num %d)#####\n",loop_count,generation,pop.get_pop_num());
	  generation++;
	  next_1_gene();
      }
      f_output();
      loop_count++;
  }while(loop_count<variable.loop_num);
  set_all_e_time();
  finish_write();
  all_open_file_close();
}

void Ncga::f_output()
{
  One::f_output(perfect_pop);
}

void Ncga::next_1_gene()
{
  int pop_num;
  pop_num=pop.get_pop_num();
  qsort(pop.ap_gene,0,pop_num-1,obj_base);
  obj_base++;
  obj_base = obj_base % variable.obj_num;
  neighbor_mix(pop.ap_gene,0,pop_num);
  real_mcc_model();
  pareto_creat();
  f_output();
  terminal_check();
}

void Ncga::ga_operator()
{
  what_times=1;
  cross.CMX_cross_over(tmpChild,send_count,what_times);
  mutation();
  function();
}

void Ncga::real_mcc_model()
{
  sp_version();
}

void Ncga::sp_version()
{
  int i,k,int_roop,pop_num,dum;
  double roop;
  pop_num=pop.get_pop_num();
  roop=(double)pop_num/send_count;
  roop=floor(roop);
  int_roop=(int)roop;

  dum=0;
  for(i=0;i<int_roop;i++){
    for(k=0;k<send_count;k++)
      *tmpChild[k]= *pop.ap_gene[i*send_count+k];
    ga_operator();
    for(k=0;k<send_count;k++,dum++){
      *next_pop.ap_gene[dum]=*tmpChild[k];  
    }
  }
  next_pop.set_pop_num(dum);
  now_pop_re_create(pop,next_pop);
}

void Ncga::mutation()
{
  mut.mut(tmpChild,send_count);
}

void Ncga::function()
{
  double time;
  time = get_time();
  func.func(tmpChild,send_count);
  func_time += get_time() - time;
}

void Ncga::function(Pop &pop)
{
  int dum;
  double time;
  time = get_time();
  dum = pop.get_pop_num();
  func.func(pop.ap_gene,dum);
  func_time += get_time() - time;
}

void Ncga::selection()
{
}

void Ncga::initialize()
{
	cout<<"pop.get_pop_num "<<pop.get_pop_num()<<endl;
  One::initialize(pop);
    
  now_pop_re_create(perfect_pop,pop);
}

void Ncga::all_open_w_file()
{
  char filename1[50],filename2[50],filename3[50],filename4[50],filename5[50],filename6[50],filename7[50],filename8[50];

	sprintf(filename1,"output_base_parameter_ncga_%d.txt",variable.func_number);

	if(variable.print_level != 1)
	  sprintf(filename2,"output_error_ncga_%d.txt",variable.func_number);

	sprintf(filename3,"output_time_ncga_%d.txt",variable.func_number);
	sprintf(filename4,"output_object_value_ncga_%d.txt",variable.func_number);

	if(variable.print_level >= 3 )
	  sprintf(filename5,"output_chromo_ncga_%d.txt",variable.func_number);

	sprintf(filename8,"output_one_ncga_%d.txt",variable.func_number);
	if(variable.print_level!=1)
	  sprintf(filename7,"output_one_ncga_plan_%d.txt",variable.func_number);

	fp1= file_open(filename1);
	if(variable.print_level != 1){
	  fp2= file_open(filename2);
	  fprintf(fp2,"func_count\t error\n");
	}
	fp3= file_open(filename3);
	fp4= file_open(filename4);

	if(variable.print_level >= 3 )
	  fp5= file_open(filename5);

	if(variable.print_level!=1)
	  fp6 = file_open(filename7);
	fp7 = file_open(filename8);
	f_set_output();
}

void Ncga::all_open_file_close()
{
  One::all_open_file_close();
}

void Ncga::now_pop_re_create(Pop &now,Pop &perfect)
{
  now.copy(perfect);
}

void Ncga::neighbor_mix(Gene **ap_gene,int first,int end)
{
        int i,j,k,dum,ran_dom,breadth;
        u8 *flag;
        int *destination;
        Gene *ap_hit;

        dum=end-first;
        destination = new int[dum];

	if(dum>50)
	  breadth = (int)((double)dum*width_rate);
	else if (dum>10)
	  breadth = (int)(dum/10);
	else if(dum>2)
	  breadth = (int)(dum/2);
	else
	  breadth=dum;

        flag = new u8[dum];

        for(i=0;i<(dum);i++)
          flag[i]=1;

        if(!destination){
          printf("destination malloc Error!\n");
          exit(1);
        }
        for(i=0;i<(dum);i++)
          destination[i]=0;
        for(i=0;i<(dum);i++){
          if((dum-i)>=breadth)
            ran_dom=mtrand.genrand_int(breadth);
          else
            ran_dom=mtrand.genrand_int(dum-i);
          k=0;
          j=0;
          do{
            if(flag[j])
              k++;
            j++;
          }while(k<=ran_dom);
          flag[(j-1)]=0;
          destination[i]=j-1;
        }
        ap_hit = new Gene[dum];
        for(i=0;i<dum;i++)
          ap_hit[destination[i]]=*ap_gene[i];
        for(i=0;i<dum;i++)
          *ap_gene[i]=ap_hit[i];
        delete [] ap_hit;
        delete [] destination;
        delete [] flag;
}









