//-------------------------------------------------------------------
// FILENAME    : ncga_mpi.h
// DESCRIPTION : Operating GA  of Parallel NCGA
//-------------------------------------------------------------------
#ifndef _NEW_PARA_MPI_H_
#define _NEW_PARA_MPI_H_

#include "ncga.h"
#include "gene.h"
#include "pop.h"
#include "base.h"

#define ROOT 0
#define UP 1
#define DOWN 0


class Ncga_mpi : public Ncga
{
    static int rank, procs;
    int RnLength;
public:
    Ncga_mpi(int& argc, char** & argv);
    virtual ~Ncga_mpi();
    virtual void cycle();
    virtual void next_1_gene();
    virtual void initGA();
    virtual void real_mcc_model();
    virtual void mp_version();
    virtual void pareto_creat();
    virtual const u8* nslc_transcription(u8 *);
    virtual int get_size_simple(Pop& pop);
    virtual int get_size_simple();
    virtual void terminal_check();
    virtual void terminal_sign();
    virtual void variable_gather();
    virtual void f_output();
    virtual void all_open_w_file();
    virtual void all_open_file_close();
};

#endif // _NEW_PARA_MPI_H_






