//-------------------------------------------------------------------
// FILENAME    : one_nsga2.cpp
// DESCRIPTION : Operating GA  of NSGA-II
//-------------------------------------------------------------------
#include <stdio.h>
#include <iostream>
#include <math.h>
#include<stdlib.h>
#include<sys/time.h>
#include "pop.h"
#include "oneisland.h"
#include "loadconf.h"
#include "one_nsga2.h"
#include "select_nsga2.h"
#include "select.h"
#include "base.h"

One_nsga2::One_nsga2():One()
{

}

void One_nsga2::initialize()
{
  One::initialize();
  archive.copy(pop);
}
void One_nsga2::initGA()
{
  init_base();
  int dum;
  dum = (int)((double)variable.pop_num+3.0);
  pop.set_pop_num(variable.pop_num);
  pop.init_ap_gene(dum);
  archive.init_ap_gene(dum);
}

void One_nsga2::o_file()
{
  set_parameter_default();
  Conffile cf("mof_nsga2.txt");
  o_file_base(cf);

  double r;
  if(cf.read("r")){
    r = atof(cf.read("r"));
    if(r>=1.0)
      r=0.9;
    select_nsga2.set_r(r);
  }
  parameter_output();
  cerr <<"nsga2 select parameter r  = " << select_nsga2.get_r() <<"\n";
}

void One_nsga2::enviroment_selection()
{
  if(get_generation()!=0)
    select_nsga2.select_nsga2(pop,archive);
}

void One_nsga2::selection()
{
  if(generation==0)
    return;
  select_nsga2.bi_select(pop);
}

void One_nsga2::next_1_gene()
{
  enviroment_selection();  
  selection();

  cross_over();
  mutation();
  function();
  f_output();
  terminal_check();
}

void One_nsga2::f_output()
{
  One::f_output(archive);
}

void One_nsga2::f_set_output()
{
	fprintf(fp1,"first_pop_num %d\n",variable.pop_num);
	fprintf(fp1,"func_number %d\n",variable.func_number);
	fprintf(fp1,"obj_num %d\nplan_num %d\n",variable.obj_num,variable.plan_num);
	fprintf(fp1,"cross_method %d\n",variable.cross_method);
	fprintf(fp1,"mut_method %d\n",variable.mut_method);
	fprintf(fp1,"select_method %d\n",variable.select_method);
	fprintf(fp1,"sharingg_pop %d\n",variable.sharing_need_pop);
	fprintf(fp1,"cross_r %f\n mut_r %f\n",variable.cross_r,variable.mut_r);
	fprintf(fp1,"end_gene %d\n",variable.end_gene);
	fprintf(fp1,"limit_func_count %d \n",variable.limit_func_count);
	fprintf(fp1,"file_in  %d \n",variable.file_in);
	if(variable.print_level!=1)
	  fprintf(fp6,"cycle %d\n",variable.loop_num);
}

void One_nsga2::all_open_w_file()
{
	char filename1[50],filename2[50],filename3[50],filename4[50],filename5[50],filename6[50],filename7[30],filename8[30];
	
	sprintf(filename1,"output_base_parameter_nsga2_%d.txt",variable.func_number);

	if(variable.print_level != 1)
	  sprintf(filename2,"output_error_nsga2_%d.txt",variable.func_number);

	sprintf(filename3,"output_time_nsga2_%d.txt",variable.func_number);
	sprintf(filename4,"output_object_value_nsga2_%d.txt",variable.func_number);

	if(variable.print_level >= 3 )
	  sprintf(filename5,"output_chromo_nsga2_%d.txt",variable.func_number);

	sprintf(filename8,"output_one_nsga2_%d.txt",variable.func_number);
	if(variable.print_level!=1)
	  sprintf(filename7,"output_plan_nsga2_%d.txt",variable.func_number);

	fp1= file_open(filename1);
	if(variable.print_level != 1){
	  fp2= file_open(filename2);
	  fprintf(fp2,"func_count\t error\n");
	}
	fp3= file_open(filename3);
	fp4= file_open(filename4);

	if(variable.print_level >= 3 )
	  fp5= file_open(filename5);

	if(variable.print_level!=1)
	  fp6 = file_open(filename7);
	fp7 = file_open(filename8);
	f_set_output();
}





