//-------------------------------------------------------------------
// FILENAME    : one_spea2_mpi.h
// DESCRIPTION : Operating GA  of Parallel SPEA2
//-------------------------------------------------------------------
#ifndef _ONE_SPEA2_MPI_H_
#define _ONE_SPEA2_MPI_H_

#include <stdio.h>
#include "one_spea2.h"
#include "pop.h"
#include "base.h"

class One_spea2_mpi : public One_spea2
{
 private:
  int rank,procs;
  const u8* nslc_transcription(u8 *buffer);
  Gene *tmpGene;
 public:
  One_spea2_mpi(int& argc, char** & argv);
  virtual ~One_spea2_mpi();
  virtual int get_size_simple(Pop& pop);
  virtual void function();
  virtual void initGA();
  virtual void cycle();
  virtual void next_1_gene();
  virtual void terminal_check();
  virtual void terminal_sign();
  virtual void variable_gather();
  virtual void all_open_w_file();
};

#endif //_ONE_SPEA2_MPI_H_




