#include <stdio.h>
#include <iostream>
#include <vector.h>
#include "pop.h"
#include "gene.h"

using namespace std;

int Pop::obj_num=2;
int Pop::plan_num=100;
int Pop::max_pop=200;

//======================================
//class Pop (pop means population)
//======================================

Pop::Pop()
{
	ap_gene = NULL;
	avg_obj=NULL;
	max_obj_value=NULL;
	min_obj_value=NULL;
	pop_num=0;
}

Pop::Pop(const Pop &f)
{
	pop_num=f.pop_num;
	init_ap_gene(pop_num);
	copy(f);
}

Pop::Pop(const int& num)
{
  Pop();
  pop_num=num;
  init_ap_gene(pop_num);
}

Pop::~Pop()
{
  int i;
  if(ap_gene){
    for(i=0;i<pop_num;i++)
      delete ap_gene[i];
    delete [] ap_gene;
  }  
  if(avg_obj)
    delete [] avg_obj;
  if(max_obj_value)
    delete [] max_obj_value;
  if(min_obj_value)
    delete [] min_obj_value;
}

// show_pop() executions that print object value of all individuals
void Pop::show_pop()
{
	int i;
	for(i=0;i<pop_num;i++){
		ap_gene[i]->Obj_printf();
	}
}

// show_pop() executions that print current object value of all individuals
void Pop::show_pop_curent()
{
	int i;
	printf("pop_num =%d\n",pop_num);
	for(i=0;i<pop_num;i++){
	  ap_gene[i]->Obj_printf_curent();
	}
}

Pop Pop::operator=(const Pop& f)
{
  int i;
  pop_num = f.pop_num;

  if(ap_gene != NULL){
    for(i=0;i<max_pop;i++)
      delete ap_gene[i];
    delete[] ap_gene;
    ap_gene=NULL;
  }
  if(avg_obj!=NULL){
    delete [] avg_obj;
    avg_obj=NULL;
  }

  if(max_obj_value!=NULL){
    delete [] max_obj_value;
    delete [] min_obj_value;
    max_obj_value=NULL;
    min_obj_value=NULL;
  }

  init_ap_gene(pop_num);
  copy(f);
  return *this;
}


Pop Pop::operator=(vector<Gene>& f)
{
  int i;
  pop_num = f.size();

  if(ap_gene != NULL){
    for(i=0;i<max_pop;i++)
      delete ap_gene[i];
    delete[] ap_gene;
    ap_gene=NULL;
  }
  if(avg_obj!=NULL){
    delete [] avg_obj;
    avg_obj=NULL;
  }
  if(max_obj_value!=NULL){
    delete [] max_obj_value;
    delete [] min_obj_value;
    max_obj_value=NULL;
    min_obj_value=NULL;
  }
  init_ap_gene(pop_num);
  for(i=0;i<pop_num;i++)
    *ap_gene[i]=f[i];
  return *this;
}

Pop Pop::operator+=(const Pop& f)
{
  int i;
  for(i=0;i<f.pop_num;i++)
    *ap_gene[pop_num+i]=*f.ap_gene[i];
  for(i=0;i<obj_num;i++)
    avg_obj[i]=(avg_obj[i]*pop_num+f.avg_obj[i]*f.pop_num)/(double)(pop_num+f.pop_num);
  
  for(i=0;i<obj_num;i++){
    if(max_obj_value[i]<f.max_obj_value[i])
      max_obj_value[i]=f.max_obj_value[i];
    if(min_obj_value[i]>f.min_obj_value[i])
      min_obj_value[i]=f.min_obj_value[i];
  }
  pop_num += f.pop_num;
  return *this;
}

// copy() executions that value of comparison Pop replace my value .
void Pop::copy(const Pop &f)
{
	int i;
	pop_num=f.pop_num;
	for(i=0;i<pop_num;i++)
		*ap_gene[i] = *f.ap_gene[i];
	for(i=0;i<obj_num;i++)
	  avg_obj[i] = f.avg_obj[i];
	for(i=0;i<obj_num;i++){
	  max_obj_value[i]=f.max_obj_value[i];
	  min_obj_value[i]=f.min_obj_value[i];
	}

}

// plus_copy() executions that value of comparison Pop add my value .
void Pop::plus_copy(const Pop &f,const int &limit)
{
  int i;
  for(i=0;i<limit;i++)
    *ap_gene[pop_num+i]=*f.ap_gene[i];
  for(i=0;i<obj_num;i++)
    avg_obj[i]=(avg_obj[i]*pop_num+f.avg_obj[i]*limit)/(double)(pop_num+limit);
  for(i=0;i<limit;i++)
    f.ap_gene[i]->safe_flag=OUT;
  pop_num += limit;
}

// show_pop_detail() shows detail my value .
void Pop::show_pop_detail()
{
        int i;
        printf("pop_num =%d\n",pop_num);
        for(i=0;i<pop_num;i++){
	  printf("[* %d]:",i);
	  ap_gene[i]->show_chromosome();
	}
}

//init_ap_gene() is for initializing class gene variable, ap_gene. 
void Pop::init_ap_gene(const int& max)
{
	int i;
	max_pop=max;
	ap_gene = new Gene*[max_pop];
	for(i=0;i<max_pop;i++){
	  ap_gene[i] = new Gene();
	}
	avg_obj = new double[obj_num];
	max_obj_value = new double[obj_num];
	min_obj_value = new double[obj_num];
	for(i=0;i<obj_num;i++){
	  avg_obj[i] = 0.0;
	  max_obj_value[i] = 0.0;
	  min_obj_value[i]=0.0;
	}
}

void Pop::f_show_obj(FILE *fp)
{
	int i;
	for(i=0;i<pop_num;i++)
		ap_gene[i]->f_show_obj(fp);
	fprintf(fp,"\n");
}

void Pop::f_show_detail(FILE *fp)
{
	fprintf(fp,"pop_num=%d :\n",pop_num);
	int i;
	for(i=0;i<pop_num;i++){
		ap_gene[i]->f_show_obj(fp);
		fprintf(fp,"\n");
		ap_gene[i]->f_chromosome(fp);
	}
}

void Pop::flag_change_out()
{
  int i;
  for(i=0;i<pop_num;i++)
    ap_gene[i]->safe_flag=OUT;
}

void Pop::flag_change_safe()
{
  int i;
  for(i=0;i<pop_num;i++)
    ap_gene[i]->safe_flag=SAFE;
}




