//-------------------------------------------------------------------
// FILENAME    : select.h
// DESCRIPTION : Selection 
//-------------------------------------------------------------------
#ifndef _Select_CPP_H_
#define _Select_CPP_H_

#include <stdlib.h>
#include <stdio.h>
#include "pop.h"
#include "mtrand.h"
#include "base.h"

class Select
{
	static int select_method;
	inline double genrand() const {return mtrand.genrand();}
        inline int normal_genrand_int(int n) const {return mtrand.genrand_int(n);}
 protected:
	int pop_num;
	static int obj_num;
	static int select_pop_num;
	static int sharing_need_pop;
	mutable MTRand mtrand;
public:
	inline int get_select_method()	{return select_method;}
	inline void set_select_method(int x)    {select_method=x;}
        inline int get_pop_num()        {return pop_num;}
        inline void set_pop_num(int x)  {pop_num=x;}
	inline void set_obj_num(int x) {obj_num=x;}
        inline int get_obj_num() {return obj_num;}
        inline void set_select_pop_num(int x) {select_pop_num=x;}
        inline int get_select_pop_num() {return select_pop_num;}
        inline void set_sharing_need_pop(int x) {sharing_need_pop=x;}
        inline int get_sharing_need_pop() {return sharing_need_pop;}

	void selection(Pop &);
	void selection(Gene **ap_gene,int &num);
	void ranking_con(Pop &);
	void ranking_con(Gene **,const int&);
	void roulet_select(Gene **,const int&);
	void ranking_square(Gene **ap_gene,int &num);
	void obj_sharing(Pop &);
	void obj_sharing(Gene **,int&,const int&);
	void bi_select(Pop &pop);
	void bi_select_alpha(Gene **ap_gene,int& dum_pop_num);
	void bi_select_alpha(Gene **ap_gene,int& dum_pop_num,const int& dum_dum);
	void tournament_select(Pop &);
	void tournament_select(Gene **ap_gene,int& dum_pop_num,const int& dum_dum);
	void tournament_select_alpha(Gene **,int &);
	void tournament_select_alpha(Gene **,int &,const int&);
	void select_pop(Pop &);
	void select_pop(Gene **,int&);
	void sort_pop(Pop &);
	void f_sort(Pop &);
	void new_sort(Pop & ,int);
	void reduce_same_pop(Pop &);
	void reduce_same_pop(Gene **,int&);
	void only_pareto_select(Pop &);
	void only_pareto_check(Gene **,const int& );
	void obj_setting(Pop &perfect);

};

extern void inssort(Gene **ap_gene,int first,int end,const int& base_obj);
extern void qsort(Gene **apGene,int first,int end,const int& base_obj);
extern void marge(Gene **apGene,int first,int end,const int& base_obj);
extern void marge_h(Gene **apGene,int first,int end,const int& base_obj,const u8 &flag);
extern void qsort_int(Gene **apGene,int first,int end,int *base);
extern void inssort_int(Gene **apGene,int first,int end,int *base);
extern void qsort(int *,int first,int end);
extern void sort(int *,int first,int end);
extern void inssort(int *,int first,int end);
extern void f_qsort(Gene **apGene,int first,int end);
extern void f_insort(Gene **apGene,int first,int end);
extern void inssort(vector<Gene>& ap_gene,int first,int end,const int& base_obj);
extern void qsort(vector<Gene>& apGene,int first,int end,const int& base_obj);
extern void f_qsort(vector<Gene>& apGene,int first,int end);
extern void f_insort(vector<Gene>& apGene,int first,int end);
#endif	//_select_CPP_H_







