//-------------------------------------------------------------------
// FILENAME    : select_nsga2.cpp
// DESCRIPTION : Selection for NSGA-II
//-------------------------------------------------------------------
#include <stdio.h>
#include <iostream>
#include <math.h>
#include <vector.h>
#include <cfloat>
#include "select.h"
#include "gene.h"
#include "pop.h"
#include "select_nsga2.h"

double Select_nsga2::r=0.0;
using namespace std;

Select_nsga2::Select_nsga2()
{
  
}

Select_nsga2::~Select_nsga2()
{
  
}


void Select_nsga2::select_nsga2(Pop& P_t,Pop& Q_t)
{
  int num;
  num=P_t.get_pop_num()*2;

  if(R_t.get_pop_num()==0)
    R_t.init_ap_gene(num);
  R_t.copy(P_t);
  R_t += Q_t; 

  obj_setting(R_t);

  F_i.clear();

  //ͥۥȤԤ,F_i 󥯤ȤΤʬहE

  fast_nondominated_sort(R_t);

  //ƥ̤̩ȽǤ˴ŤŬٳ䤁EƤԤ.
  crowding_distatnce_assignment();
  make_new_pop(P_t);
  Q_t.copy(P_t);
}

void Select_nsga2::fast_nondominated_sort(Pop &R_t)
{
  int i,k,N,m,s;
  u16 j;
  Gene p,q;
  
  N= R_t.get_pop_num();
  int n_p[N];

  S_q_list S_p[N]; // dominate number
  vector<int> list,next_list,flag; 
  vector<Gene> H;
  Dumy_pop dumy_pop;

  vector<int>::iterator vp;

  flag.resize(N);

  for(i=0;i<N;i++){
    n_p[i]=0;
    flag[i]=SAFE;
  }

  for(i=0;i<N;i++){
    p = *R_t.ap_gene[i];
    for(j=i+1;j<N;j++){
      q = *R_t.ap_gene[j];
      m=k=0;
      for(s=0;s<obj_num;s++){
        if(p.obj[s] < q.obj[s])
          m +=1;
        else if(p.obj[s] > q.obj[s])
          k +=1;
	else if(p.obj[s] == q.obj[s]){
	  m ++;
	  k ++;
	}
      }
      if(m==obj_num){
	n_p[j] += 1; //n_p is number of  dominated myself. 
	S_p[i].domin.push_back(j);  //S_p is dominat number.
      }
      else if(k==obj_num){
	n_p[i] += 1;
	S_p[j].domin.push_back(i);
      }
    }
    if(n_p[i] == 0&&flag[i]){
      H.push_back(p);
      list.push_back(i);
      flag[i]=OUT;
    }
  }
  int point_num,S_p_size;
  dumy_pop=H;


  F_i.push_back(dumy_pop);
  i=0;
  do{
    H.clear();
    next_list.clear();    
    for(j=0;j<list.size();j++){

      p = F_i[i].domin[j];

      point_num = list[j];  //list is list of front individ

      S_p_size = S_p[point_num].domin.size();
      vp= S_p[point_num].domin.begin();

      for(k=0;k<S_p_size;k++,vp++){
	n_p[*vp] -= 1;
	if(n_p[*vp]==0&&flag[*vp]){
	  H.push_back(*R_t.ap_gene[*vp]);
	  next_list.push_back(*vp);
	  flag[*vp]=OUT;
	}
      }
    }
    list.clear();

    vp = list.begin();
    list.insert(vp,next_list.begin(),next_list.end());	
    i++;
    dumy_pop=H;
    F_i.push_back(dumy_pop);
  }while(F_i[i].size()!=0);
}

void Select_nsga2::crowding_distatnce_assignment()
{
  u16 i,j;
  for(i=0;i<F_i.size();i++){
    if(F_i[i].size()==0)
      break;
    crowding_distatnce_assignment(F_i[i]);
  }

  double base;
  for(i=(F_i.size()-2);i>0;i--){
    base = F_i[i].domin[0].get_f();
    for(j=0;j<F_i[i-1].size();j++){
      F_i[i-1].domin[j].get_f() += base;
    }
  }
}

void Select_nsga2::crowding_distatnce_assignment(Dumy_pop& F_1)
{
  int i,j;
  int pop_num;
  pop_num=F_1.size();
  
  vector<double> distance(pop_num);

  for(i=0;i<pop_num;i++){
    F_1.domin[i].get_f()=0.0;
  }
  for(j=0;j<obj_num;j++){
    F_1.sort(j);
    F_1.domin[0].get_f() = INT_MAX/16.0;
    F_1.domin[(pop_num-1)].get_f() = INT_MAX/16.0;
    for(i=1;i<(pop_num-1) ;i++){
      F_1.domin[i].get_f() += (F_1.domin[i-1].get_c(j)-F_1.domin[i+1].get_c(j));
    }
  }
  F_1.f_sort();
}


void Select_nsga2::crowding_distatnce_assignment(Pop& pop)
{
  int i,j;
  int pop_num;
  pop_num=pop.get_pop_num();
  vector<double> distance(pop_num);

  for(i=0;i<pop_num;i++){
    pop.ap_gene[i]->get_f()=0.0;
  }
  for(j=0;j<obj_num;j++){
    new_sort(pop,j);

    pop.ap_gene[0]->get_f() = DBL_MAX/2.0;
    pop.ap_gene[pop_num]->get_f() = DBL_MAX/2.0;
    for(i=1;i<(pop_num-1);i++){
      pop.ap_gene[i]->get_f() += (pop.ap_gene[i-1]->get_c(j)-pop.ap_gene[i+1]->get_c(j));
    }
  }
  f_sort(pop);
}

void Select_nsga2::make_new_pop(Pop& P_t)
{
  int N,sum,K;
  u16 i,j;
  vector<int> n_t; // n_t,Υ󥯤ˤE緲)
  vector<double> n_i; //n_i ,ºݤǤEΥ󥯤ˤEпξ

  double value;

  N = P_t.get_pop_num();

  for(i=0;F_i[i].size() !=0 ;i++){
    n_t.push_back(F_i[i].domin.size());
    F_i[i].flag_change_safe();
  }

  K=n_t[0];
  value=N*(1.0-r)/(1.0-pow(r,K));
  n_i.push_back(value);
  sum = (int)n_i[0];
  for(i=1;sum<N;i++){
    value=n_i[i-1]*r;
    value=ceil(value);
    n_i.push_back(value);
    sum += (int)n_i[i];
  }

  int dum,rou=0;
  P_t.set_pop_num(0);
  for(i=0;(i<(n_i.size()))&&i<(n_t.size());i++){
    dum = P_t.get_pop_num();
    if(dum>=N) // пãõλ
      break;
    n_i[i] +=(double)rou;
    if(n_t[i]>=n_i[i]){
      for(j=0;(j<n_i[i])&&(dum+j)!=N;j++){
	*P_t.ap_gene[dum+j]= F_i[i].domin[j];
	F_i[i].domin[j].safe_flag=OUT;
      }
      P_t.set_pop_num(dum+j);
      rou=0;
    }
    else if(n_t[i]<n_i[i]){
      for(j=0;j<(F_i[i].size())&&(dum+j)!=N;j++)
	*P_t.ap_gene[dum+j]=F_i[i].domin[j];
      P_t.set_pop_num(dum+j);
      F_i[i].flag_change_out();
      rou=(int)(n_i[i]-n_t[i]);
    }
  }

  i=0;
  while(P_t.get_pop_num() < N){
    force_put(P_t,F_i[i],N);
    i++;
  }
}

void Select_nsga2::force_put(Pop& P_t,Dumy_pop &F_1,const int& N)
{
  int i,pop_num;
  pop_num = P_t.get_pop_num();
  for(i=0;i<(F_1.size());i++){
    if(F_1.domin[i].safe_flag==SAFE){
      *P_t.ap_gene[pop_num]= F_1.domin[i];
      pop_num ++;
    }
    if(pop_num==N)
      break;
  }
  P_t.set_pop_num(pop_num);
}

void Select_nsga2::full_mix(Pop& pop,Pop& perfect)
{
  int i,p_pop,m,pop_pop;

  p_pop = perfect.get_pop_num();
  pop_pop = pop.get_pop_num();
  m=0;
  for(i=0;i<pop_pop;i++){
    if(pop.ap_gene[i]->get_f()==1)
      m++;
  }
  for(i=0;i<p_pop;i++){
    if(perfect.ap_gene[i]->get_f()==1)
      m++;
  }
  if(m>pop_pop){
    only_pareto_check(pop.ap_gene,pop_pop);
    only_pareto_check(perfect.ap_gene,p_pop);
    select_pop(perfect);
    p_pop=perfect.get_pop_num();
    pop_pop=pop.get_pop_num();

    m=0;
    for(i=0;i<pop_pop;i++){
      if(pop.ap_gene[i]->safe_flag==OUT)
        continue;
      *perfect.ap_gene[p_pop+m] = *pop.ap_gene[i];
      m++;
    }
    p_pop += m;
    perfect.set_pop_num(p_pop);

    crowding_distatnce_assignment(perfect);
    tournament_select(perfect.ap_gene,p_pop,pop_pop);
    perfect.set_pop_num(pop_pop);
  }
  else{
    f_sort(pop);
    f_sort(perfect);
    int pop_check,perfect_check;
    
    pop_pop=pop.get_pop_num();
    for(i=0;i<pop_pop;i++)
      pop.ap_gene[i]->safe_flag=OUT;
    for(i=0;i<p_pop;i++)
      perfect.ap_gene[i]->safe_flag=OUT;
    pop_check=perfect_check=0;

    for(i=0;i<pop_pop;i++){
      if(perfect.ap_gene[perfect_check]->get_f()>=pop.ap_gene[pop_check]->get_f()&&perfect_check<p_pop){
        perfect.ap_gene[perfect_check]->safe_flag=SAFE;
        perfect_check ++;
      }
      else{
        pop.ap_gene[pop_check]->safe_flag=SAFE;
        pop_check ++;
      }
    }
    select_pop(perfect);
    p_pop=perfect.get_pop_num();
    m=0;
    pop_pop=pop.get_pop_num();
    for(i=0;i<pop_pop;i++){
      if(pop.ap_gene[i]->safe_flag==OUT)
        continue;
      *perfect.ap_gene[p_pop+m] = *pop.ap_gene[i];
      m++;
    }
    p_pop +=m;
    perfect.set_pop_num(p_pop);
  }
}


Dumy_pop Dumy_pop::operator=(const vector<Gene>& f)
{
  copy(f);
  return *this;
}

Dumy_pop Dumy_pop::operator=(const Dumy_pop& f)
{
  copy(f);
  return *this;
}

void Dumy_pop::copy(const vector<Gene>& f)
{
  u16 i;
  i=f.size();

  domin.clear();
  domin.reserve(i);

  for(i=0;i<f.size();i++)
    domin.push_back(f[i]);
}

void Dumy_pop::copy(const Dumy_pop& f)
{
  u16 i;
  i=f.domin.size();
  domin.resize(i);
  for(i=0;i<f.domin.size();i++)
    domin[i]=f.domin[i];
}

Dumy_pop Dumy_pop::operator+=(Dumy_pop& f)
{
  u16 num;
  num=f.size();
  plus_copy(f,num);
  return *this;
}

void Dumy_pop::plus_copy(Dumy_pop& f,const int& n)
{
  int i;
  vector<Gene>::iterator p;

  p = f.domin.begin();

  for(i=0;i<n;i++,p++)
    domin.push_back(*p);
}

void Dumy_pop::flag_change_out()
{
  int i;
  for(i=0;i<size();i++)
    domin[i].safe_flag=OUT;
}

void Dumy_pop::flag_change_safe()
{
  int i;
  for(i=0;i<size();i++)
    domin[i].safe_flag=SAFE;
}

void Dumy_pop::f_sort()
{
  int dum;

  dum=size()-1;
  f_qsort(domin,0,dum);

}

void Dumy_pop::sort(int &n)
{
  int dum;
  dum=size()-1;
  qsort(domin,0,dum,n);
}

void Dumy_pop::show_pop()
{
  int i;
  printf("pop_num %d\n",size());
  for(i=0;i<size();i++)
    domin[i].Obj_printf();
}
