//-------------------------------------------------------------------
// FILENAME    : select_nsga2.h
// DESCRIPTION : Selection for NSGA-II
//-------------------------------------------------------------------
#ifndef _Select_Nsga2_CPP_H_
#define _Select_Nsga2_CPP_H_

#include <stdlib.h>
#include <stdio.h>
#include <vector>
#include "pop.h"

class Dumy_pop
{
 public: 
  vector<Gene> domin;
  Dumy_pop operator=(const vector<Gene>& f);
  Dumy_pop operator=(const Dumy_pop&);
  Dumy_pop operator+=(Dumy_pop&);
  void copy(const vector<Gene>& f);
  void copy(const Dumy_pop&);
  int size() {return domin.size();}
  void plus_copy(Dumy_pop& f,const int& n);
  void flag_change_out();
  void flag_change_safe();
  void   f_sort();
  void   sort(int &);
  void show_pop();
};

class Select_nsga2 : public Select
{
  Pop R_t;
  vector<Dumy_pop> F_i;
 protected:
  static double r; 
public: 
  Select_nsga2();
  virtual ~Select_nsga2();
  void select_nsga2(Pop& P_t,Pop& Q_t);
  void fast_nondominated_sort(Pop &);
  void crowding_distatnce_assignment();
  void crowding_distatnce_assignment(Dumy_pop& );
  void crowding_distatnce_assignment(Pop& );
  void nsga2(Pop& ,Pop& );
  void make_new_pop(Pop&);
  void force_put(Pop& P_t,Dumy_pop &F_i,const int& N);
  void enviroment_selection();
  inline void set_r(double& val) {r=val;}
  inline double get_r() {return r;}
  virtual void full_mix(Pop& pop,Pop& perfect);
};

struct S_q_list
{
  vector<int> domin;
};

#endif	//_Select_Nsga2_CPP_H_

