//-------------------------------------------------------------------
// FILENAME    : select_spea2.cpp
// DESCRIPTION : Selection for SPEA2
//-------------------------------------------------------------------
#include <stdio.h>
#include <iostream>
#include <math.h>
#include <vector.h>
#include <cfloat>
#include "select.h"
#include "gene.h"
#include "pop.h"
#include "select_spea2.h"
#include "base.h"

using namespace std;
int Select_spea2::obj_base=1;

Select_spea2::Select_spea2()
{

}

Select_spea2::~Select_spea2()
{
}

void Select_spea2::select_spea2(Pop& P_t,Pop& Q_t)
{
  int num;
  
  if(Q_t.get_pop_num()>P_t.get_pop_num())
    num=Q_t.get_pop_num()*2;
  else
    num=P_t.get_pop_num()*2;

  if(R_t.get_pop_num()==0)
    R_t.init_ap_gene(num);
  R_t.copy(P_t);
  R_t += Q_t;

  obj_setting(R_t);
  fitness_assignment(R_t);
  copy(R_t,Q_t);
  P_t.copy(Q_t);
}



void Select_spea2::select_spea2(Pop& P_t,const int& N)
{
  int num;
  num=N*2;

  obj_setting(P_t);
  fitness_assignment(P_t);
  copy(P_t,N); 
}

void Select_spea2::fitness_assignment(Pop &P_t)
{
  int i,j,m,k,pop_num;
  u16 s;

  pop_num=P_t.get_pop_num();

  S_q_list S_p[pop_num];  //S_p is number of individ that domain myself.
  vector<int> count(pop_num);

  for(i=0;i<pop_num;i++)
    count[i]=0;

  for(i=0;i<pop_num;i++){
    for(s=i+1;s<pop_num;s++){
      m=k=0;
      for(j=0;j<obj_num;j++){
        if(P_t.ap_gene[i]->obj[j] < P_t.ap_gene[s]->obj[j])
          m +=1;
        else if(P_t.ap_gene[i]->obj[j] > P_t.ap_gene[s]->obj[j])
          k +=1;
	else if(P_t.ap_gene[i]->obj[j] == P_t.ap_gene[s]->obj[j]){
	  m ++;
	  k ++;
	}
      }
      if(m==obj_num){
        count[i] += 1;
	S_p[s].domin.push_back(i);
      }
      else if(k==(obj_num)){
        count[s] += 1;
	S_p[i].domin.push_back(s);
      }
    }
  }

  int dum;
  for(i=0;i<pop_num;i++){
    dum = 0;
    for(s=0;s<S_p[i].domin.size();s++){
      j=S_p[i].domin[s];
      dum += count[j];
    }
    P_t.ap_gene[i]->get_f() = 1.0/(double)(dum+1);
  }
}


void Select_spea2::copy(Pop& R_t,Pop& Q_t)
{
  int i,j,N;
  N=Q_t.get_pop_num();
  
  for(i=0;i<R_t.get_pop_num();i++)
    R_t.ap_gene[i]->safe_flag=SAFE;

  for(i=j=0;i<R_t.get_pop_num()&&j<N;i++){
    if(R_t.ap_gene[i]->get_f()==1){
      *Q_t.ap_gene[j]=*R_t.ap_gene[i];
      R_t.ap_gene[i]->safe_flag=OUT;
      j++;
    }
  }
  Q_t.set_pop_num(j);
  if(j==N){ //over case
  	
    pop_num=R_t.get_pop_num();
    only_pareto_check(R_t.ap_gene,pop_num);
//	printf("over over over over over ---- NOW pop %d -> %d  \n",pop_num,N);
//	R_t.set_pop_num(pop_num);
    select_pop(R_t);    
    truncation_operator(R_t,N);
    Q_t.copy(R_t);
  }
  else if(j<N){ //lower case
    select_pop(R_t);
    f_sort(R_t);
    plus(R_t,Q_t,N);
  }
  //  cout<<"copy fin \n";
}

void Select_spea2::copy(Pop& R_t,const int& N)
{
  int i,j;  
  for(i=0;i<R_t.get_pop_num();i++)
    R_t.ap_gene[i]->safe_flag=SAFE;
  for(i=j=0;i<R_t.get_pop_num()&&j<N;i++){
    if(R_t.ap_gene[i]->get_f()==1){
      j++;
    }
  }
  if(j==N){ //over case
    only_pareto_check(R_t.ap_gene,pop_num);
    select_pop(R_t);    
    truncation_operator(R_t,N);
  }
  else if(j<N){ //lower case
    f_sort(R_t);
    plus(R_t,N);
  }
}

void Select_spea2::plus(Pop& R_t,Pop& Q_t,const int& N)
{
  int i,pop_num,dis;
  pop_num = Q_t.get_pop_num();
  dis=N-pop_num;
  for(i=0;i<dis;i++){
    *Q_t.ap_gene[pop_num+i]=*R_t.ap_gene[i];
  }
  Q_t.set_pop_num(N);
}

void Select_spea2::plus(Pop& R_t,const int& N)
{
  int i;
  for(i=0;i<N;i++){
    R_t.ap_gene[i]->safe_flag=SAFE;
  }
  select_pop(R_t);
}

//void Select_spea2::truncation_operator(Pop &Q_t,const int& N)
	void Select_spea2::crowding_distatnce_assignment(Pop &Q_t,const int& N)
{
  int i,j,k,pop_num,hit;
  double min_dist,dist;
  u8 flag;

  pop_num=Q_t.get_pop_num();
  while(N<pop_num){
    for(i=0;i<pop_num;i++){
      Q_t.ap_gene[i]->get_f()=0.0;
    }
    
    for(j=0;j<obj_num;j++){
      new_sort(Q_t,j);
      //      cout<<"sort(base on obj) :"<<endl;
      //      Q_t.show_pop();      
      Q_t.ap_gene[pop_num-1]->get_f() = INT_MAX/16.0;
      for(i=1;i<(pop_num-1) ;i++){
	Q_t.ap_gene[i]->get_f() += (Q_t.ap_gene[i-1]->get_c(j)-Q_t.ap_gene[i+1]->get_c(j));
      }
    }
    f_sort(Q_t);
    //    cout<<"Q_t.ap_gene[0]->get_f();"<<Q_t.ap_gene[0]->get_f()<<endl;
    //    cout<<"Q_t.ap_gene[pop_num-1]->get_f();"<<Q_t.ap_gene[pop_num-1]->get_f()<<endl;
    pop_num--;
    Q_t.set_pop_num(pop_num);
  }
}

double Select_spea2::distance_calcurate(Gene& a,Gene& b){
	double dumy=0.0,dum=0.0;
	for(int j=0;j<obj_num;j++){
		dum = a.get_c(j) - b.get_c(j);
		dumy += dum*dum;
	}
	dumy=sqrt(dumy);
	return dumy;
}


void Select_spea2::minimum_reserve_fix(Pop &a,vector<double>& reserve_number)
{
	int i,j,k,pop_num;
	double min_fx[obj_num],value;
	pop_num = a.get_pop_num();
	
	for(i=0;i<reserve_number.size();i++){
		reserve_number[i]=0;
	}
	
	for(k=0;k<obj_num;k++){
	  min_fx[k]=a.ap_gene[0]->obj[k];
	  for(i=1;i<pop_num;i++){
	    value = a.ap_gene[i]->obj[k];
		if(min_fx[k]>value){
	      min_fx[k]=value;
	      reserve_number[k]=i;
	    }
	  }
	}
	
//	printf("reserve_number:\t");
//	for(i=0;i<reserve_number.size();i++){
//		cout<<reserve_number[i]<<",";
//	}
//	cout<<"\n";
}


void Select_spea2::truncation_operator(Pop &Q_t,const int& N)
{
  int i,j,k,pop_num,d_hit,del_hit,hit[2];
  vector< int > sub_hit;
  double min_dist,dist;
  vector<double> sub_min;
  u8 flag;
  
  obj_setting(Q_t);
  
  pop_num=Q_t.get_pop_num();

  vector <double> reserve_number;
  if(obj_num<N){
  	  reserve_number.resize(obj_num);
  	  minimum_reserve_fix(Q_t,reserve_number);
  }
	else{
		reserve_number.resize(0);
	}
  int del_number=0;
  
  while(N<(Q_t.get_pop_num()-del_number)){
    min_dist = DBL_MAX/4.0;
 	hit[0]=0; hit[1]=1;
    for(i=0;i<(Q_t.get_pop_num()-1);i++){
    	if(Q_t.ap_gene[i]->safe_flag==OUT)
    		continue;
    	for(k=0;k<(Q_t.get_pop_num());k++){
    		if(i==k||Q_t.ap_gene[k]->safe_flag==OUT)
    			continue;
	      dist=distance_calcurate(*Q_t.ap_gene[i],*Q_t.ap_gene[k]);
	      
//    	  for(j=0;j<obj_num;j++)
//			dist += fabs(Q_t.ap_gene[i]->get_c(j) - Q_t.ap_gene[k]->get_c(j));
 	     if(min_dist>dist){
			min_dist=dist;
			hit[0]=i;
			hit[1]=k;
 	     }
 	    }
    }
    
	sub_hit.resize(0);
	sub_min.resize(0);
	
	del_hit=-1;
	
	for(i=0;i<reserve_number.size();i++){
		if(reserve_number[i]==hit[0])
			del_hit=hit[1];
		else if(reserve_number[i]==hit[1])
			del_hit=hit[0];
	}
	
	while(del_hit<0){
	    for(k=0;k<2;k++){
   		    min_dist = DBL_MAX/4.0;
	  		for(i=0;i<(Q_t.get_pop_num());i++){
	 	 		if(hit[0]==i||hit[1]==i||Q_t.ap_gene[i]->safe_flag==OUT)
	  				continue;
	 	 		flag=0;
				for(j=0;j<(sub_hit.size()-k);j++){
					if(i==sub_hit[j])
						flag=1;
				}
				if(flag)
					continue;
			
		    	dist=distance_calcurate(*Q_t.ap_gene[hit[k]],*Q_t.ap_gene[i]);
//	    	  	for(j=0;j<obj_num;j++)
//					dist += fabs(Q_t.ap_gene[hit[k]]->get_c(j) - Q_t.ap_gene[i]->get_c(j));
				if(min_dist>dist){
					min_dist=dist;
					d_hit=i;
				}
			}
			sub_hit.push_back(d_hit);
			sub_min.push_back(min_dist);
//			cout<<" HIT["<<k<<"] dist ("<<hit[0]+1<<" sub_hit "<<d_hit+1<<" = "<<min_dist<<endl;
	  	}
	  	
//	  	cout<<" HIT[0] dist ("<<hit[0]+1<<", "<<sub_min[sub_min.size()-2]<<endl;
//	  	cout<<" HIT[1] dist ("<<hit[1]+1<<", "<<sub_min[sub_min.size()-1]<<endl;
	  	
  		if(sub_min[sub_min.size()-2] < sub_min[sub_min.size()-1] )
  			del_hit=hit[0];
  		else if(sub_min[sub_min.size()-2] > sub_min[sub_min.size()-1])
  			del_hit=hit[1];
  	}
  	
//	cout<<"delete point "<<del_hit+1<<endl;
	Q_t.ap_gene[del_hit]->safe_flag=OUT;
	del_number++;
	//	select_pop(Q_t);
  }
	select_pop(Q_t);
}

