#ifndef _GENE_CPP_H_
#define _GENE_CPP_H_

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <vector>
#include "base.h"
#include "mtrand.h"
using namespace std;

#define SAFE 1
#define OUT 0
#define CHANGE 1
#define NOCHANGE 0
#define HIGHT 1
#define WIDTH 0

class Gene;

class Obj 
{
	static int obj_num;
	double fitness_value;
	double *eval_value;
	double *const_eval;
	friend class Gene;
public:
	Obj();
	Obj(int);
	Obj(const Obj&);
	~Obj();
	void copy(const Obj&);
	double& operator[](int i) {return eval_value[i];}
	double& get_c_eval(int i) {return const_eval[i];}
	double& get_fit() {return fitness_value;}
	u8 operator<(const Obj &dum);
	u8 operator>(const Obj &dum);
	u8 operator<=(const Obj &dum);
	u8 operator>=(const Obj &dum);
	void Obj_printf();
	void Obj_printf_curent();
	Obj operator=(const Obj&);
	inline static void set_obj_num(int x) {obj_num=x;}
	inline static int get_obj_num()  {return obj_num;}
};

class Chromo
{
  u8 locus_r;
  friend class Gene;
 public:
  Chromo operator=(const Chromo&);
  Chromo operator=(const int&);
  operator int() {return (int)locus_r;}
  operator u8() {return locus_r;}
  operator bool() {if(locus_r==1) return true;else return false;}
  bool operator==(const Chromo&);
  u8 operator^(const Chromo&);
  void f_out(FILE *fp);
};

class Gene
{
  static int Rna_size;
  static vector<double> variable_min;
  static vector<double> variable_max;
 protected:
  vector< Chromo > locus;
  static int real_chrom;
  static int plan_num;
  static int obj_num;
 public:
  u8 safe_flag;
  u8 change_flag;
  Obj obj;
  Gene();
  Gene(const int&);
  Gene(const int& ,const int&);
  Gene(const Gene&);
  virtual ~Gene();
  Gene init(const int& ,const int&);
  void copy(const Gene&);
  inline Chromo& get_locus(const int &x)	{return locus[x];}  
  double get_locus_value(const int &x) const;
  double get_locus_value_p(const int &x) const;
  double get_variable_value(const int& start,const int& end) const;
  void set_locus_value(const double *value);
  void set_locus_value(const vector <double> value);
  void set_locus_value(const int &point,const double& value);
  void set_variable_value(const int& start,const int& end,long long num);
  static int get_plan_num() {return plan_num;}
  double& get_c(int i) {return obj.const_eval[i];}	
  double& get_e(int i) {return obj[i];}
  double& get_f() {return obj.fitness_value;}
  inline void set_size(size_t n) 
    {
      locus.resize(n);
      if(!real_chrom)  real_chrom=n;
    }
  inline int size() const {return locus.size();}
  inline static int get_chromo_len() {return real_chrom;}
  //	inline void reserve(size_t n){locus.reserve(n);}
  vector<Chromo>::iterator erase(vector<Chromo>::iterator n) {return locus.erase(n);}
  vector<Chromo>::iterator begin() {return locus.begin();}
  
  inline static void set_obj_num(const int& x) {obj_num=x,Obj::set_obj_num(x);}
  static void set_parameter(const int& x,const int& y,const int& z);
  static void set_func_num(const int& func_num);
  
    inline int get_obj_num() {return obj_num;}	
  
  int GetRnaLength();
  inline int get_size() {return GetRnaLength();}
  int GetRnaLength_set();
  Gene operator=(const Gene&);
  Chromo& operator()(const int& n) {return locus[n];}
  Chromo& operator[](const int& n) {return locus[n];}
  virtual bool operator==(const Gene&);
  virtual void show_chromosome();
  void f_show_obj(FILE *);
//  void f_show_obj_s(FILE *);
  virtual void f_chromosome(FILE *);
  virtual void f_show_plan_value(FILE *fp);
  void printf_para();
  inline void Obj_printf()	{obj.Obj_printf();}
  inline void Obj_printf_curent()	{obj.Obj_printf_curent();}
  virtual const u8* transcription(u8 *buffer);
  virtual void reverse_transcription(const u8 *data);
  virtual void reverse_transcription2(const u8 *data);
};

#endif	//_GENE_CPP_H



